#include "fbase.h"


/*******************************************************

Procdure de recherche de l'arbre de recouvrement

Convention :
tete_L1 : liste  traiter (contient le chemin de M0  M)
tete_L2 : liste des situations dj traites
M : Nouveau marquage obtenu
i : indice de Places
j : indice de transitions

*******************************************************/

int recouvrement(int nb_T,
                 int nb_P,
                 int pre[][MAX_T],
                 int inc[][MAX_T],
                 int M0[MAX_P])
{
	struct listeListe *L1, *tete_L1, *pCourantL1 ;
	struct listeVecteur *L2, *tete_L2, *pCourantL2, *pCourantChemin, *pCourantL ;
	int M[MAX_P], V_pre[MAX_P] ;
	int i, j ;
	int blocage ;
	int arret = FALSE ;
	int reseau_borne = TRUE ;
  int interruption_procedure = FALSE ;
	short chx ;
  
	tete_L2 = NULL ;
	pCourantL2 = tete_L2 ;
	L1 =  (struct listeListe*)malloc(sizeof(struct listeListe));
	L1->pSuivant = NULL ;
	tete_L1 = L1 ;
	pCourantL1 = L1 ;
  L2 =  (struct listeVecteur*)malloc(sizeof(struct listeVecteur));
	pCourantL1->tete_Chemin = L2 ;

	for (i=0; i<nb_P; i++)
      {
				tete_L1->V[i] = M0[i] ;
        L2->V[i] = M0[i] ;
      }

  L2->pSuivant = NULL ;
 
	do
	{
		blocage = TRUE ;

/* Pour toute les transition j=1..nb_T	*/

		for (j=0; j<nb_T; j++)
		{
       	for (i=0; i<nb_P; i++)
					V_pre[i] = pre[i][j] ;

			if (V1supV2(tete_L1->V,V_pre,nb_P) == TRUE)
			{

/* la transition j est tirable  partir du maquage tete_L1->V */
			
				blocage = FALSE ;
				for (i=0; i<nb_P; i++)
					if (tete_L1->V[i] != MAX_ENTIER)
						M[i] = tete_L1->V[i]+inc[i][j] ;
          else
           	M[i] = MAX_ENTIER ;

/* on cherche si le vecteur M est strictement suprieur  un
	autre marquage dans le chemin */

				pCourantChemin = tete_L1->tete_Chemin ;
				while (pCourantChemin != NULL)
				{
				
					if(V1supV2(M,pCourantChemin->V,nb_P) == TRUE)
						for (i=0; i<nb_P; i++)
						{
							if (M[i] > pCourantChemin->V[i])
							{
								reseau_borne = FALSE ;
								M[i] = MAX_ENTIER ;
							}
						}
					pCourantChemin = pCourantChemin->pSuivant ;
				}

				if ((VestdansLL( M, tete_L1, nb_P) == FALSE) && (VestdansLV( M, tete_L2, nb_P) == FALSE ))
				{

/* On ajoute M  L1 */

					if ((L1 = (struct listeListe*)malloc(sizeof(struct listeListe))) == NULL)
						return FALSE ;
 
          pCourantL1->pSuivant = L1;
					for (i=0; i<nb_P; i++)
						L1->V[i] = M[i] ;

					L1->pSuivant = NULL ;
					pCourantL1 = L1 ;

/* On recopie le chemin de tete_L1 (+ marquage M) dans L1  */

					pCourantChemin = tete_L1->tete_Chemin ;

					if ((L2 = (struct listeVecteur*)malloc(sizeof(struct listeVecteur))) == NULL)
						return FALSE ;

					for (i=0; i<nb_P; i++)
							L2->V[i] = M[i] ;

					pCourantL1->tete_Chemin = L2 ;
					pCourantL = L2 ;

          do
					{
						if ((L2 = (struct listeVecteur*)malloc(sizeof(struct listeVecteur))) == NULL)
								return FALSE ;

						for (i=0; i<nb_P; i++)
							L2->V[i] = pCourantChemin->V[i] ;

						pCourantL->pSuivant = L2 ;
						pCourantL = pCourantL->pSuivant ;
            pCourantChemin = pCourantChemin->pSuivant ;
					}
					while (pCourantChemin != NULL) ;  // while (pCourantChemin->pSuivant != NULL) ;  vrifier
					pCourantL->pSuivant = NULL ;
					
				}

				clrscr() ;
				afficheV(tete_L1->V,nb_P) ;
				printf("\n\n-> T%d ->\n\n",j+1) ;
				afficheV(M,nb_P) ;
				if (tete_L1->pSuivant != NULL)
				{
					printf("\n\nESC:end or Press a Key") ;
					chx = ngetchx() ;
					if (chx == KEY_ESC)
      		{
						arret = TRUE ;
  	    		interruption_procedure = TRUE ;
  	    		j = nb_T ;
      		}
				}
			}
		}

		if (blocage == TRUE)
		{
			clrscr() ;
			printf("Deadlock for\n") ;
			afficheV(tete_L1->V,nb_P) ;
			if (tete_L1->pSuivant != NULL)
			{
				printf("\n\nESC:end or Press a Key") ;
				chx = ngetchx() ;
				if (chx == KEY_ESC)
      	{
					arret = TRUE ;
  	    	interruption_procedure = TRUE ;
      	}
			}

		}


/* On rajoute le marquage tete_L1 dans L2 */

		if ((L2 = (struct listeVecteur*)malloc(sizeof(struct listeVecteur))) == NULL)
			return FALSE ;
		if (tete_L2 == NULL)
			tete_L2 = L2 ;
		else
			pCourantL2->pSuivant = L2;
		for (i=0; i<nb_P; i++)
			L2->V[i] = tete_L1->V[i] ;
		L2->pSuivant = NULL ;
		pCourantL2 = L2 ;

/* On efface le chemin du marquage de tete_L1 dans L1 */

		L1 = tete_L1->pSuivant ;
		pCourantChemin = tete_L1->tete_Chemin ;
		while (pCourantChemin != NULL)
		{
			L2 = pCourantChemin->pSuivant ;
			free(pCourantChemin) ;
			pCourantChemin = L2 ;
		}

/* On efface tete_L1	*/

		free(tete_L1) ;
		if (L1 == NULL)
			arret = TRUE ;
		else
			tete_L1 = L1 ;

	}
	while (arret == FALSE) ;

	printf("\n\n") ;
   if (interruption_procedure == FALSE)
   {
		if (reseau_borne == TRUE)
			printf("bounded Net") ;
		else
			printf("No bounded Net") ;
		ngetchx() ;
   }


/* On efface la liste L2 pour librer la mmoire */

	pCourantL2 = tete_L2 ;
	while (pCourantL2 != NULL)
	{
		L2 = pCourantL2->pSuivant ;
		free(pCourantL2) ;
		pCourantL2 = L2 ;
	}
	return TRUE ;
}






/*******************************************************

Procdure de recherche des situations stables

Convention :
L1 : liste  traiter
L2 : liste des situations dj traites
M : Nouveau marquage obtenu
i : indice de Places
j : indice de transitions

*******************************************************/

int situation(int nb_T,
              int nb_P,
              int pre[][MAX_T],
              int inc[][MAX_T],
              int M0[MAX_P])
{
	struct listeVecteur *L1, *L2, *tete_L1, *tete_L2 ;
	struct listeVecteur *pCourantL1, *pCourantL2 ;
	int M[MAX_P], V_pre[MAX_P] ;
	int i, j ;
	int blocage ;
	int arret = FALSE ;
	short chx ;
	tete_L2 = NULL ;
	pCourantL2 = tete_L2 ;
	L1 =  (struct listeVecteur*)malloc(sizeof(struct listeVecteur));
	L1->pSuivant = NULL ;
	tete_L1 = L1 ;
	pCourantL1 = L1 ;
	for (i=0; i<nb_P; i++)
		tete_L1->V[i] = M0[i] ;
	do
	{
		blocage = TRUE ;
		for (j=0; j<nb_T; j++)
		{
         for (i=0; i<nb_P; i++)
           	V_pre[i] = pre[i][j] ;
			if (V1supV2(tete_L1->V,V_pre,nb_P) == TRUE)
			{
				blocage = FALSE ;
				for (i=0; i<nb_P; i++)
					M[i] = tete_L1->V[i]+inc[i][j] ;

				clrscr() ;
				afficheV(tete_L1->V,nb_P) ;
				printf("\n\n-> T%d ->\n\n",j+1) ;
				afficheV(M,nb_P) ;
				printf("\n\nESC:end or Press a Key") ;
				chx = ngetchx() ;
				if (chx == KEY_ESC)
				{
					j = nb_T ;
					arret = TRUE ;
				}				

				if ((VestdansLV( M, tete_L1, nb_P) == FALSE) && (VestdansLV( M, tete_L2, nb_P) == FALSE ))
				{
					if ((L1 = (struct listeVecteur*)malloc(sizeof(struct listeVecteur))) == NULL)
						return FALSE ;
					pCourantL1->pSuivant = L1;
					for (i=0; i<nb_P; i++)
						L1->V[i] = M[i] ;
					L1->pSuivant = NULL ;
					pCourantL1 = L1 ;
				}
			}
		}
		if (blocage == TRUE)
		{
			clrscr() ;
			printf("Deadlock for\n") ;
			afficheV(tete_L1->V,nb_P) ;
			if (tete_L1->pSuivant != NULL)
			{
				printf("\n\nESC:end or Press a Key") ;
				chx = ngetchx() ;
				if (chx == KEY_ESC)
					arret = TRUE ;
			}
		}

		if ((L2 = (struct listeVecteur*)malloc(sizeof(struct listeVecteur))) == NULL)
			return FALSE ;
		if (tete_L2 == NULL)
			tete_L2 = L2 ;
		else
			pCourantL2->pSuivant = L2;
		for (i=0; i<nb_P; i++)
			L2->V[i] = tete_L1->V[i] ;
		L2->pSuivant = NULL ;
		pCourantL2 = L2 ;

		L1 = tete_L1->pSuivant ;
		free(tete_L1) ;
		if (L1 == NULL)
		{
			printf("\n\nEnd : Press a Key") ;
			ngetchx() ;	
			arret = TRUE ;	
		}			
		else
			tete_L1 = L1 ;

	}
	while (arret == FALSE) ;

	pCourantL2 = tete_L2 ;
	while (pCourantL2 != NULL)
	{
		L2 = pCourantL2->pSuivant ;
		free(pCourantL2) ;
		pCourantL2 = L2 ;
	}

	return TRUE ;
}
