/*******************************************************

Procdure de recherche des circuits lmentaires

Convention :
tete_k : liste des possibilits de tirage
i : indice de Places
j : indice de transitions
*******************************************************/

#include "fbase.h"

int circuits(int nb_T,
             int nb_P,
             int pre[][MAX_T],
             int post[][MAX_T])
{
 	struct listeHybrid *tete_k, *pCourantK, *pK ;
	int i, j, l, indice_P, indice_suivant, type_suivant ;
   int suivant_OK, suivant_est_dans_K ;
   int solutions = FALSE ;
   clrscr() ;

   for(indice_P=0; indice_P<nb_P; indice_P++)
   {
   	tete_k =  (struct listeHybrid*)malloc(sizeof(struct listeHybrid));
      pCourantK = tete_k ;
		tete_k->pSuivant = NULL ;
   	tete_k->pPrecedent = NULL ;
      tete_k->indice = indice_P ;
      tete_k->type = TYPE_P ;
      tete_k->k = 0 ;
      while (tete_k != NULL)
      {
      	pCourantK->k += 1 ;
         suivant_OK = FALSE ;
         suivant_est_dans_K = FALSE ;
         l = 0 ;
         if (pCourantK->type == TYPE_P)
           	type_suivant = TYPE_T ;
         else
           	type_suivant = TYPE_P ;

         switch(type_suivant)
         {

          	case TYPE_T :

/* On recherche le successeur (T) de la Place dans la matrice pre */

            	{
                	i = 0 ;
                  while ((i < nb_T) && (l < pCourantK->k ))
                	{
                  	if (pre[pCourantK->indice][i] !=0)
                     {
                      	l++ ;
                      	if (l == pCourantK->k)
                          	{
                             	suivant_OK = TRUE ;
                              indice_suivant = i ;
                           }
                     }
                  	i++ ;
                  }
                	break ;
               }

            case TYPE_P :

/* On recherche le successeur (P) de la Transition dans la matrice post */

               {
                	j = 0 ;
                  while ((j < nb_P) && (l < pCourantK->k ))
                	{
                  	if (post[j][pCourantK->indice] !=0)
                     {
                      	l++ ;
                      	if (l == pCourantK->k)
                          	{
                             	suivant_OK = TRUE ;
                              indice_suivant = j ;
                           }
                     }
                  	j++ ;
                  }
               	break ;
               }
         }

			switch(suivant_OK)
         {
				case FALSE :

/* si il n'y a pas de successeur, on supprime le sommet */

            {
          		pK = pCourantK->pPrecedent ;
            	free(pCourantK) ;
            	pCourantK = pK ;
            	if (pK==NULL)
              		tete_k = NULL;

               break ;
            }

            case TRUE :
            {

/* On vrifie si le nouveau successeur n'a pas dj t trouv */

               pK = tete_k ;
            	while ((pK != NULL) && (suivant_est_dans_K == FALSE))
            	{
               	if ((indice_suivant == pK->indice) && (type_suivant == pK->type))
                 		suivant_est_dans_K = TRUE;
            		pK = pK->pSuivant ;
            	}

					if ((indice_suivant == indice_P) && (type_suivant == TYPE_P))

/* On a trouv un nouveau circuit lmentaire */

					{
          			pK = tete_k ;
            		solutions = TRUE ;
								FontSetSys (F_4x6);
            		printf("{ ") ;

            		while (pK != NULL)
            		{
               		if (pK->type == TYPE_P)
                 			printf("P%d ",pK->indice+1) ;
               		else
                  		printf("T%d ",pK->indice+1) ;
            			pK = pK->pSuivant ;
            		}
         			printf("P%d }\n",indice_suivant+1) ;
							FontSetSys (F_6x8);
         		}


					if ((suivant_est_dans_K == FALSE) && ((indice_suivant > indice_P) || (type_suivant == TYPE_T)))

/* On rajoute un nouveau successeur si indice_suivant > indice_P (cas si suivant est une place ) */

            	{
						if ((pK = (struct listeHybrid*)malloc(sizeof(struct listeHybrid))) == NULL)
							return FALSE ;
              		pCourantK->pSuivant = pK ;
              		pK->pSuivant = NULL ;
              		pK->indice = indice_suivant ;
              		pK->type = type_suivant ;
              		pK->pPrecedent = pCourantK ;
              		pK->k = 0 ;
            		pCourantK = pK ;
            	}

               break ;
            }
         }


      }

   }

  if (solutions == FALSE)
     	printf("\nNo elementary circuits\n") ;
     	
  printf("\nPress a Key") ;
	ngetchx() ;

	return TRUE ;
}
