#include "fbase.h"


/*******************************************************

Maximum entre deux entiers a et b

*******************************************************/

int maxi(int a, int b)
{
	if (a > b) return (a);
	else return (b);
}




/*******************************************************

Minimum entre deux entier a et b

*******************************************************/

int mini(int a, int b)
{
	 if (a < b) return (a);
	 else return (b);
}



/*******************************************************

Procdure de comparaison = de deux vecteurs

Argument renvoy : TRUE si V1 = V2
						 FALSE si V1 <> V2

*******************************************************/

int V1egaleV2( int V1[MAX_P],
               int V2[MAX_P],
               int nb)
{
	int i ;
	for (i=0; i<nb; i++)
		{
			if (V1[i] != V2[i]) return FALSE ;
		}
	return TRUE ;
}





/*************************************************************************

Procdure de contrle prsence d'un vecteur Vect dans une liste de Vecteur

Argument renvoy : TRUE si V est dans L
						 FALSE sinon

*************************************************************************/

int VestdansLV( int Vect[MAX_P],
                struct listeVecteur *L,
                int taille_V)
{
	struct listeVecteur *P ;
	if (L == NULL)
		return FALSE ;
	P = L ;
	do
	{
		if (V1egaleV2( Vect, P->V, taille_V) == TRUE)
			return TRUE ;
		P = P->pSuivant;
	}
	while (P != NULL) ;
	return FALSE ;
}






/***********************************************************************

Procdure de contrle prsence d'un vecteur Vect dans une liste de liste

Argument renvoy : TRUE si V est dans L
						 FALSE sinon

************************************************************************/

int VestdansLL( int Vect[MAX_P],
                struct listeListe *L,
                int taille_V)
{
	struct listeListe *P ;
	if (L == NULL)
		return FALSE ;
	P = L ;
	do
	{
		if (V1egaleV2( Vect, P->V, taille_V) == TRUE)
			return TRUE ;
		P = P->pSuivant;
	}
	while (P != NULL) ;
	return FALSE ;
}





/*******************************************************

Procdure de comparaison >= de deux vecteurs

Argument renvoy : TRUE si V1 >= V2
						 FALSE si V1 < V2

*******************************************************/

int V1supV2( int V1[MAX_P],
             int V2[MAX_P],
             int nb )
{
	int i ;
	for (i=0; i<nb; i++)
		{
			if (V1[i] < V2[i]) return FALSE ;
		}
	return TRUE ;
}






/*******************************************************

Procdure d'affichage d'un vecteur V de taille nb

*******************************************************/

void afficheV( int V[MAX_P],
               int nb)
{
	int i ;
	FontSetSys (F_4x6);
	printf("[") ;
	for (i=0; i<nb; i++)
		if (V[i]==MAX_ENTIER)
			printf("%3c",'w') ;
		else
			printf("%3d",V[i]) ;
	printf("  ]") ;
	FontSetSys (F_6x8);
}







/*********************************************************

Calcul du PGCD de deux entiers

*********************************************************/

int pgcd (int a, int b)
{
/* FACT: 0 < b <= a */
	int q,r;
	do
		{
			q = a / b;
			r = a - q*b;
			a = b;
			b = r;
		}
	while (b > 0);
	return a;
}






/********************************************************

Procdure qui vrifie que M.(1 .. 1) = 0

si M.V = 0 : TRUE
sinon : FALSE

variables :
	M : matrice (nb_l*nb_c)
	(1 .. 1) : vecteur unitaire (nb_l)
	nb_l : nombre de ligne de M et nombre d'lments de V
	nb_c : nombre de colonne de M

********************************************************/

int M_multp_Ident_est_nulle(int M[][NBMAX],
                            int nb_l,
                            int nb_c)
{
	int i, j, plop ;
	for (i=0; i<nb_l; i++)
	{
		plop = 0;
		for(j=0; j<nb_c; j++)
			plop += M[i][j] ;
		if (plop != 0) return FALSE ;
	}
	return TRUE ;

}





/*********************************************************

Procdure d'affichage d'un tableau de dimensions nb_P*nb_T

*********************************************************/

void aff_mat(int tab[][NBMAX],
             int nb_P,
             int nb_T )
{
	int i , j ;
	FontSetSys (F_4x6);
	for (i=0; i<nb_P; i++)
		{
			printf("|") ;
			for (j=0; j<nb_T; j++)
				printf("%4d",tab[i][j]) ;
			printf("   |\n") ;
		}
	FontSetSys (F_6x8);
}


