#include "fbase.h"


/*******************************************************

Procdure d'ouverture/lecture fichier de donnes

*******************************************************/

void lecture_fichier(int *nb_T,
                     int *nb_P,
                     int pre[][MAX_T],
                     int post[][MAX_T],
                     int inc[][MAX_T],
                     int tr_inc[][MAX_P],
                     int M0[MAX_P] )

{
	FILE *fichier ;
	char *nom_fichier ;
  int i, j, argtype ;
  ESI argptr;

  InitArgPtr (argptr);
  
	if ((argtype = GetArgType (argptr)) != END_TAG)
    {
    	if (argtype == STR_TAG)
      	nom_fichier = GetStrnArg (argptr) ;
      else
			{
				clrscr() ;
				printf("Bad Data\n\nPress a Key");
				ngetchx() ;
				exit(1) ;
			}  

    }
  else
	{
		clrscr() ;
		printf("No Data File\n\nPress a Key");
		ngetchx() ;
		exit(1) ;
	}  
 
	if ((fichier = fopen(nom_fichier,"r")) == NULL)
	{
		clrscr() ;
		printf("Reading error of data file\n'%s'\n\nPress a Key",nom_fichier);
		ngetchx() ;
		exit(1) ;
	}
	fscanf(fichier,"%d",nb_P) ;
	fscanf(fichier,"%d",nb_T) ;
	if ((*nb_T > MAX_T) || (*nb_P > MAX_P))
	{
		clrscr() ;	
		printf("Error: Numbre of places\n(or transitions) maxi = \n%d (%d)\n\nPress a Key",MAX_P,MAX_T) ;
		ngetchx() ;
		exit(1) ;
	}
	if ((*nb_T==0) || (*nb_P==0))
	{
		clrscr() ;		
		printf("Error: Number of places\n(or transitions) = 0\n\nPress a Key") ;
		ngetchx() ;
		exit(1) ;
	}
	for (i=0; i<*nb_P; i++)
	{
		for (j=0; j<*nb_T; j++)
			fscanf(fichier,"%d",&pre[i][j]) ;
	}
	for (i=0; i<*nb_P; i++)
	{
		for (j=0; j<*nb_T; j++)
			fscanf(fichier,"%d",&post[i][j]) ;
	}

	for (i=0; i<*nb_P; i++)
		fscanf(fichier,"%d",&M0[i]) ;

	for (i=0; i<*nb_P; i++)
		for (j=0; j<*nb_T; j++)
			{
				inc[i][j] = post[i][j]- pre[i][j] ;
				tr_inc[j][i] = inc[i][j] ;
			}
	fclose(fichier) ;
}





/*********************************************************

Procdure d'affichage des donnes

*********************************************************/

void affichage(int nb_T, int nb_P,
               int pre[][MAX_T],
               int post[][MAX_T],
               int inc[][MAX_T],
               int tr_inc[][MAX_P],
               int M0[MAX_P])
{
	clrscr() ;
	printf("Number of Places: %d\nNumber of Transitions: %d\n",nb_P,nb_T);

	printf("\nPress a Key") ;
	ngetchx() ;
	clrscr() ;
	
	printf("Matrix W- (P->T):\n") ;
	aff_mat(pre,nb_P,nb_T) ;
	
	printf("\nPress a Key") ;
	ngetchx() ;
	clrscr() ;

	printf("Matrix W+ (T->P):\n") ;
	aff_mat(post,nb_P,nb_T) ;
	
	printf("\nPress a Key") ;
	ngetchx() ;
	clrscr() ;

	printf("Incidence Matrix:\n") ;
	aff_mat(inc,nb_P,nb_T) ;
	
	printf("\nPress a Key") ;
	ngetchx() ;
	clrscr() ;

	printf("Initial Marking M0:\n") ;
	afficheV(M0,nb_P) ;

	printf("\n\nPress a Key") ;
	ngetchx() ;
	clrscr() ;

	if (M_multp_Ident_est_nulle(tr_inc,nb_T,nb_P) == TRUE)
	{
		printf("Conservative and ") ;
		printf("\n");
		printf("structurally bounded\n\n") ;
	}
	else
		printf("No conservative\n\n") ;

	if (M_multp_Ident_est_nulle(inc,nb_P,nb_T) == TRUE)
	{
		printf("Consistency and ") ;
		printf("\n");
		printf("structurally repetitive\n") ;
	}
	else
		printf("No consistency\n") ;
		
	printf("\nPress a Key") ;
	ngetchx() ;
	clrscr() ;
}






/****************************************************************

Procdure d'affichage du crdit

****************************************************************/

void about ()
{
	static WIN_RECT rect = {0, 0, 158, 91};

	clrscr() ;
	FontSetSys (F_6x8);
  DrawStr (30, 4, "Petri89 V2.0 BETA", A_NORMAL);
  FontSetSys (F_4x6);
  DrawStr (70, 14, "By", A_NORMAL);
  DrawStr (50, 27, "Laurent Damay", A_NORMAL);
  DrawStr (20, 42, "Universit de Picardie Jules Vernes", A_NORMAL);
  DrawStr (55, 57, "IUT de l'Aisne", A_NORMAL);
  DrawStr (30, 72, "laurent.damay@u-picardie.fr", A_NORMAL);
  DrawStr (35, 84, "www.iut-aisne.fr/webogp/", A_NORMAL);
  DrawClipRect (&rect, ScrRect, A_THICK1);
	FontSetSys (F_6x8);
  ngetchx() ;
}

