/*				Petri89 v 2.0 BETA 				*/
/*				Par Laurent Damay					*/
/* syntaxe petri89("fichier_de_donnes")

structure de fichier_de_donnes:

nombre_de_place nombre_de_transition

matrice W- (P->T)		(dim nombre_de_place*nombre_de_transition)

matrice W+ (T->P)		(dim nombre_de_place*nombre_de_transition)

Marquage initial M0	(dim nombre_de_place)

Exemple :

3 2

1 0
0 1
0 1

0 1
1 0
1 0

1 0 0

********************************************/

#include "fbase.h"
#include "simul.h"
#include "semif.h"
#include "circuits.h"
#include "arbres.h"
#include "fdivers.h"



int pre[MAX_P][MAX_T] ;
int post[MAX_P][MAX_T] ;
int inc[MAX_P][MAX_T] ;
int tr_inc[MAX_T][MAX_P] ;
int M0[MAX_P] ;
int nb_T ;
int nb_P ;



/****************************************************************

Boucle principale

****************************************************************/

void _main( void )
{

	short choix ;

	FontSetSys (F_6x8);
    
	lecture_fichier(&nb_T,&nb_P,pre,post,inc,tr_inc,M0) ;
	
	do
	{
		clrscr ();
		printf("PETRI89 V2.0 BETA\n\n") ;
		printf("1- View Matrix\n2- P-invariants\n3- T-invariants\n4- Simulation of Sequence\n5- Reachability Tree\n6- Coverability Tree\n7- Elementary Circuits\n8- About\nESC- End") ;
    choix = ngetchx() ;

		switch(choix)
		{
			case '1' :
				{
					affichage(nb_T,nb_P,pre,post,inc,tr_inc,M0) ;
					break ;
				}

			case '2' :
				{
					semif(inc,nb_P,nb_T,PINV,M0) ;
					break ;
				}

			case '3' :
				{
					semif(tr_inc,nb_T,nb_P,TINV,M0) ;
					break ;
				}

			case '4' :
				{
					if (sequence(nb_T,nb_P,pre,inc,M0) == FALSE)
					{
						printf("\nError: Memory Overflow\n\nPress a Key") ;
						ngetchx() ;
					}
					break ;
				}

      case KEY_ESC : break ;

			case '5' :
				{
					if (situation(nb_T,nb_P,pre,inc,M0) == FALSE)
					{
						printf("\nError: Memory Overflow\n\nPress a Key") ;
						ngetchx() ;
					}
					break ;
				}

			case '6' :
				{
					if (recouvrement(nb_T,nb_P,pre,inc,M0) == FALSE)
					{
						printf("\nError: Memory Overflow\n\nPress a Key") ;
						ngetchx() ;
					}
					break ;
				}

			case '7' :
				{
					if (circuits(nb_T,nb_P,pre,post) == FALSE)
					{
						printf("\nError: Memory Overflow\n\nPress a Key") ;
						ngetchx() ;
					}
					break ;
				}

			case '8' :
				{
					about() ;
					break ;
				}

			default :
				{
					break ;
				}
		}
	}
	while (choix != KEY_ESC) ;
}
