#include "fbase.h"

/****************************************************************

Algorithme de calcul des semi-flots (P-inv, T-inv)

****************************************************************/

void semif(int mat_inc[][NBMAX],
           int nb_P, int nb_T,
           int code_semif,
           int M0[MAX_P])
{
	int i, j, k, l ;
	int n = nb_P ;
	int l_tab2, nb_l ;
	int plop ;
	int symbole_p  ;
	int diviseur ;
	int tab[MAX_P*(MAX_P+1)/2][MAX_P+MAX_T], tab2[MAX_P*(MAX_P+1)/2][MAX_P+MAX_T] ;
	for (i=0; i<nb_P;i++)
		for (j=0; j<nb_P;j++)
			if (i != j)
				tab[i][j] = 0 ;
			else
				tab[i][j] = 1 ;
	for (i=0; i<nb_P;i++)
		for (j=nb_P;j<nb_T+nb_P;j++)
			tab[i][j] = mat_inc[i][j-nb_P] ;
	nb_l = nb_P ;
	do
	{
		l_tab2 = 0 ;
		for (k=0; k<nb_l; k++)
		{
			if (tab[k][n] == 0)
			{
				for (j=0; j<nb_T+nb_P;j++)
					tab2[l_tab2][j] = tab[k][j] ;
				l_tab2++ ;

			}
			else
			{
				for (l=k; l<nb_l; l++)
				{
					if (tab[l][n]*tab[k][n] < 0)
					{
						diviseur = pgcd(maxi(abs(tab[l][n]), abs(tab[k][n])),mini(abs(tab[l][n]), abs(tab[k][n])));

						for (j=0; j<nb_T+nb_P;j++)
							tab2[l_tab2][j] = (tab[l][j]*abs(tab[k][n])+tab[k][j]*abs(tab[l][n]))/diviseur ;
						l_tab2++ ;

					}
				}
			}
		}

		if (l_tab2 != 0 )
		{
			nb_l = l_tab2 ;
			for (i=0; i<l_tab2; i++)
				for(j=0; j<nb_T+nb_P; j++)
					tab[i][j] = tab2[i][j] ;
		}
		n++ ;
	}
	while ((n <nb_T+nb_P)&&(l_tab2 !=0)) ;

	if (l_tab2 !=0)
	{
	  clrscr() ;
	  if (code_semif == PINV)
	  	printf("P") ;
	  else
	  	printf("T") ;
		printf("-invariants:\n") ;
		FontSetSys (F_4x6);
	
		for (i=0; i<nb_l; i++)
		{
			printf("[") ;
			for (j=0; j<nb_P; j++)
				printf("%3d",tab2[i][j]) ;
			printf("  ]\n") ;
		}
		FontSetSys (F_6x8);

		printf("\nPress a Key\n") ;
		ngetchx() ;
		clrscr() ;
		if (code_semif == PINV)
		{
			printf("State Equations:\n") ;
			FontSetSys (F_4x6);
		
			for (i=0; i<nb_l; i++)
			{
				symbole_p = FALSE ;
				for (j=0; j<nb_P; j++)
					{
						if ((tab2[i][j] != 0)&&(symbole_p == FALSE))
						{
							symbole_p = TRUE ;
						}
						else
						{
							if (tab2[i][j] != 0)
								printf("+") ;
						}
						switch(tab2[i][j])
						{
							case 0 : break ;
							case 1 : printf("M(P%d)",j+1) ; break ;
							default : printf("%dM(P%d)",tab2[i][j],j+1) ; break ;
						}

					}
					plop = 0 ;
					for (j=0;j<nb_P;j++)
						plop += tab2[i][j]*M0[j] ;
					printf("=%d\n",plop) ;
				}
			FontSetSys (F_6x8);
			printf("\nPress a Key") ;
			ngetchx() ;
			clrscr() ;
		}
	}
	else
	{
		clrscr() ;
		printf("No invariants\n\nPress a Key") ;
		ngetchx() ;
	}

}
